Surface Filling: Difference between revisions

From FreeCAD Documentation
(Marked this version for translation)
(The sections will be called "Boundary edges", "Non-boundary edges", "Non-boundary vertices")
Line 47: Line 47:


<!--T:16-->
<!--T:16-->
* Inside the {{MenuCommand|Filling}} section.
* Inside the {{MenuCommand|Boundary edges}} section.
** {{Button|Add edge}}: press once to start picking edges in the [[3D_view|3D view]]. Individual lines such as {{Button|[[File:Draft_BSpline.svg|16px]] [[Draft_BSpline|Draft BSplines]]}} and {{Button|[[File:Sketcher_CreateBSpline.svg|16px]] [[Sketcher_CreateBSpline|Sketcher BSplines]]}} can be chosen, as well as any edge from solid objects, like those of {{Button|[[File:PartDesign_Body.svg|16px]] [[PartDesign_Body|PartDesign Bodies]]}} and {{Button|[[File:Part_Primitives.svg|16px]] [[Part_Primitives|Part Primitives]]}}.
** {{Button|Add edge}}: press once to start picking edges in the [[3D_view|3D view]]. Individual lines such as {{Button|[[File:Draft_BSpline.svg|16px]] [[Draft_BSpline|Draft BSplines]]}} and {{Button|[[File:Sketcher_CreateBSpline.svg|16px]] [[Sketcher_CreateBSpline|Sketcher BSplines]]}} can be chosen, as well as any edge from solid objects, like those of {{Button|[[File:PartDesign_Body.svg|16px]] [[PartDesign_Body|PartDesign Bodies]]}} and {{Button|[[File:Part_Primitives.svg|16px]] [[Part_Primitives|Part Primitives]]}}.
** {{Button|Remove edge}}: press once to start picking edges in the [[3D_view|3D view]]; these must be edges that were previously picked with {{Button|Add edge}}.
** {{Button|Remove edge}}: press once to start picking edges in the [[3D_view|3D view]]; these must be edges that were previously picked with {{Button|Add edge}}.
Line 54: Line 54:


<!--T:17-->
<!--T:17-->
* Inside the {{MenuCommand|Unbound Edges}} section similar {{Button|Add edge}} and {{Button|Remove edge}} buttons are available to pick supporting edges to control the curvature of the original surface.
* Inside the {{MenuCommand|Non-boundary edges}} section similar {{Button|Add edge}} and {{Button|Remove edge}} buttons are available to pick supporting edges to control the curvature of the original surface.
* Inside the {{MenuCommand|Filling}} section similar {{Button|Add vertex}} and {{Button|Remove vertex}} buttons are available, in this case to pick supporting vertices.
* Inside the {{MenuCommand|Non-boundary vertices}} section similar {{Button|Add vertex}} and {{Button|Remove vertex}} buttons are available, in this case to pick supporting vertices.
* Press {{Button|Cancel}} or {{KEY|Esc}} to abort the current operation.
* Press {{Button|Cancel}} or {{KEY|Esc}} to abort the current operation.



Revision as of 20:19, 2 October 2020

This documentation is not finished. Please help and contribute documentation.

GuiCommand model explains how commands should be documented. Browse Category:UnfinishedDocu to see more incomplete pages like this one. See Category:Command Reference for all commands.

See WikiPages to learn about editing the wiki pages, and go to Help FreeCAD to learn about other ways in which you can contribute.

Surface Filling

Menu location
Surface → Filling...
Workbenches
Surface
Default shortcut
None
Introduced in version
0.17
See also
None

Description

Surface Filling creates a surface from a series of connected boundary edges.

The surface can be modified by adding constraint edges and vertices which the surface must pass through.

Example of a filled surface, delimited by four edges located in the XY plane; (left) only the four edges, and (right) one additional curve in space that defines the curvature of the surface

Usage

  1. Make sure you have at lease three edges or curves in space forming a closed contour. For example, these can be created with tools of the Draft Workbench or the Sketcher. Using three edges would create a triangular surface; four edges a quadrilateral surface.
    • Optionally, curves can be drawn inside the closed contour, not necessarily touching the edges. These curves can be used to control the curvature of the resulting surface.
    • Likewise, a number of vertices can be used with the same purpose to indicate where the surface must go through.
  2. Press the Surface filling button.
  3. Inside the Filling section, press Add edge.
  4. Use the pointer to pick the desired edges in the 3D view; a preview of the final shape will be shown after selecting valid edges that form a closed contour.
    • Optionally, to control the curvature of the surface, go to the Unbound edges section, press Add edge, and pick the desired edges from the 3D view.
    • Optionally, to control the curvature by means of vertices, go to the Vertices section, press Add vertex, and pick the desired vertices from the 3D view.
  5. Press OK to complete the operation.

The base edges that form the closed contour, as well as the auxiliary vertices and edges, can belong to 2D curves from Draft or the Sketcher, but can also belong to 3D solid objects such as those created with the Part or PartDesign Workbenches.

Options

  • Inside the Boundary edges section.
  • Right mouse button: open the context menu and select Remove, or press Del in the keyboard, to remove the currently selected edge in the list.


  • Inside the Non-boundary edges section similar Add edge and Remove edge buttons are available to pick supporting edges to control the curvature of the original surface.
  • Inside the Non-boundary vertices section similar Add vertex and Remove vertex buttons are available, in this case to pick supporting vertices.
  • Press Cancel or Esc to abort the current operation.

Properties

A Surface Filling (Surface::Filling class) is derived from the basic Part Feature (Part::Feature class, through the Part::Spline subclass), therefore it shares all the latter's properties.

In addition to the properties described in Part Feature, the Surface Filling has the following properties in the property editor.

Data

Filling

  • DataBoundary Edges (LinkSubList): boundary edges; C0 is required for edges without a corresponding face.
  • DataBoundary Faces (StringList):
  • DataBoundary Order (IntegerList): order of constraint on boundary faces; 0, 1, and 2 are possible.
  • DataUnbound Edges (LinkSubList): unbound constraint edges; C0 is required for edges without a corresponding face.
  • DataUnbound Faces (StringList):
  • DataUnbound Order (IntegerList): order of constraint on unbound faces; 0, 1, and 2 are possible.
  • DataFree Faces (LinkSubList): free constraint on a face.
  • DataFree Order (IntegerList): order of constraint on free faces.
  • DataPoints (LinkSubList): constraint points on surface.
  • DataInitial Face (LinkSub): initial surface to use.
  • DataDegree (Integer): starting degree, it defaults to 3.
  • DataPoints On Curve (Integer): number of points on an edge for constraint.
  • DataIterations (Integer): number of iterations, it defaults to 2.
  • DataAnisotropy (Bool): it defaults to false.
  • DataTolerance2d (Float): 2D tolerance, it defaults to 0.0.
  • DataTolerance3d (Float): 3D tolerance, it defaults to 0.0.
  • DataTol Angular (Float): G1 tolerance, it defaults to 0.01.
  • DataTol Curvature (Float): G2 tolerance, it defaults to 0.10.
  • DataMaximum Degree (Integer): maximum curve degree, it defaults to 8.
  • DataMaximum Segments (Integer): maximum number of segments, it defaults to 9.

View

Base

  • ViewControl Points (Bool): it defaults to false; if set to true, it will show an overlay with the control points of the surface.

Scripting

See also: FreeCAD Scripting Basics.

The Surface Filling tool can be used in macros and from the Python console by adding the Surface::Filling object.

  • The edges to be used to define the surface must be assigned as a LinkSubList to the BoundaryEdges property of the object.
  • Auxiliary edges and vertices must be assigned as a LinkSubLists to the UnboundEdges and Points properties of the object.
  • All objects with edges need to be computed before they can be used as input for the properties of the Filling object.
import FreeCAD as App
import Draft

doc = App.newDocument()

a = App.Vector(-20, -20, 0)
b = App.Vector(-18, 25, 0)
c = App.Vector(60, 26, 0)
d = App.Vector(33, -20, 0)

points1 = [a, App.Vector(-20, -8, 0), App.Vector(-17, 7, 0), b]
obj1 = Draft.make_bspline(points1)

points2 = [b, App.Vector(0, 25, 0), c]
obj2 = Draft.make_bspline(points2)

points3 = [c, App.Vector(37, 4, 0), d]
obj3 = Draft.make_bspline(points3)

points4 = [d, App.Vector(-2, -18, 0), a]
obj4 = Draft.make_bspline(points4)
doc.recompute()

surf = doc.addObject("Surface::Filling", "Surface")
surf.BoundaryEdges = [(obj1, "Edge1"),
                      (obj2, "Edge1"),
                      (obj3, "Edge1"),
                      (obj4, "Edge1")]
doc.recompute()

# ---------------------------------------------------------
points_spl = [App.Vector(-10, 0, 2),
              App.Vector(4, 0, 7),
              App.Vector(18, 0, -5),
              App.Vector(25, 0, 0),
              App.Vector(30, 0, 0)]
aux_edge = Draft.make_bspline(points_spl)
doc.recompute()

surf.UnboundEdges = [(aux_edge, "Edge1")]
doc.recompute()

# ---------------------------------------------------------
aux_v1 = Draft.make_line(App.Vector(-13, -12, 5),
                         App.Vector(-13, -12, -5))
aux_v2 = Draft.make_line(App.Vector(-3, 18, 5),
                         App.Vector(-3, 18, -5))
doc.recompute()

surf.Points = [(aux_v1, "Vertex2"),
               (aux_v2, "Vertex1")]
doc.recompute()